// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: AdventureControl.proto
#ifdef _MSC_VER
#pragma warning(disable:4125)
#endif
#include "AdventureControl.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/io/zero_copy_stream_impl_lite.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)

namespace protobuf_AdventureControl_2eproto {
extern PROTOBUF_INTERNAL_EXPORT_protobuf_AdventureControl_2eproto ::google::protobuf::internal::SCCInfo<1> scc_info_MovementOption;
}  // namespace protobuf_AdventureControl_2eproto
namespace protobuf_RemoteFortressReader_2eproto {
extern PROTOBUF_INTERNAL_EXPORT_protobuf_RemoteFortressReader_2eproto ::google::protobuf::internal::SCCInfo<0> scc_info_Coord;
}  // namespace protobuf_RemoteFortressReader_2eproto
namespace AdventureControl {
class MoveCommandParamsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MoveCommandParams>
      _instance;
} _MoveCommandParams_default_instance_;
class MovementOptionDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MovementOption>
      _instance;
} _MovementOption_default_instance_;
class MenuContentsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MenuContents>
      _instance;
} _MenuContents_default_instance_;
class MiscMoveParamsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MiscMoveParams>
      _instance;
} _MiscMoveParams_default_instance_;
}  // namespace AdventureControl
namespace protobuf_AdventureControl_2eproto {
static void InitDefaultsMoveCommandParams() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::AdventureControl::_MoveCommandParams_default_instance_;
    new (ptr) ::AdventureControl::MoveCommandParams();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::AdventureControl::MoveCommandParams::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<1> scc_info_MoveCommandParams =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 1, InitDefaultsMoveCommandParams}, {
      &protobuf_RemoteFortressReader_2eproto::scc_info_Coord.base,}};

static void InitDefaultsMovementOption() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::AdventureControl::_MovementOption_default_instance_;
    new (ptr) ::AdventureControl::MovementOption();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::AdventureControl::MovementOption::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<1> scc_info_MovementOption =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 1, InitDefaultsMovementOption}, {
      &protobuf_RemoteFortressReader_2eproto::scc_info_Coord.base,}};

static void InitDefaultsMenuContents() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::AdventureControl::_MenuContents_default_instance_;
    new (ptr) ::AdventureControl::MenuContents();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::AdventureControl::MenuContents::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<1> scc_info_MenuContents =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 1, InitDefaultsMenuContents}, {
      &protobuf_AdventureControl_2eproto::scc_info_MovementOption.base,}};

static void InitDefaultsMiscMoveParams() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::AdventureControl::_MiscMoveParams_default_instance_;
    new (ptr) ::AdventureControl::MiscMoveParams();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::AdventureControl::MiscMoveParams::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_MiscMoveParams =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsMiscMoveParams}, {}};

void InitDefaults() {
  ::google::protobuf::internal::InitSCC(&scc_info_MoveCommandParams.base);
  ::google::protobuf::internal::InitSCC(&scc_info_MovementOption.base);
  ::google::protobuf::internal::InitSCC(&scc_info_MenuContents.base);
  ::google::protobuf::internal::InitSCC(&scc_info_MiscMoveParams.base);
}

}  // namespace protobuf_AdventureControl_2eproto
namespace AdventureControl {
bool AdvmodeMenu_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 9:
    case 10:
    case 11:
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
    case 17:
    case 18:
    case 19:
    case 20:
    case 21:
    case 22:
    case 23:
    case 24:
    case 25:
    case 26:
    case 27:
    case 28:
    case 29:
    case 30:
    case 31:
    case 32:
    case 33:
    case 34:
    case 35:
    case 36:
    case 37:
    case 38:
    case 39:
    case 40:
    case 41:
    case 42:
    case 43:
    case 44:
    case 45:
    case 46:
      return true;
    default:
      return false;
  }
}

bool CarefulMovementType_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 9:
    case 10:
    case 11:
    case 12:
      return true;
    default:
      return false;
  }
}

bool MiscMoveType_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 2:
      return true;
    default:
      return false;
  }
}


// ===================================================================

void MoveCommandParams::InitAsDefaultInstance() {
  ::AdventureControl::_MoveCommandParams_default_instance_._instance.get_mutable()->direction_ = const_cast< ::RemoteFortressReader::Coord*>(
      ::RemoteFortressReader::Coord::internal_default_instance());
}
void MoveCommandParams::clear_direction() {
  if (direction_ != NULL) direction_->Clear();
  clear_has_direction();
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MoveCommandParams::kDirectionFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MoveCommandParams::MoveCommandParams()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_AdventureControl_2eproto::scc_info_MoveCommandParams.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:AdventureControl.MoveCommandParams)
}
MoveCommandParams::MoveCommandParams(const MoveCommandParams& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_direction()) {
    direction_ = new ::RemoteFortressReader::Coord(*from.direction_);
  } else {
    direction_ = NULL;
  }
  // @@protoc_insertion_point(copy_constructor:AdventureControl.MoveCommandParams)
}

void MoveCommandParams::SharedCtor() {
  direction_ = NULL;
}

MoveCommandParams::~MoveCommandParams() {
  // @@protoc_insertion_point(destructor:AdventureControl.MoveCommandParams)
  SharedDtor();
}

void MoveCommandParams::SharedDtor() {
  if (this != internal_default_instance()) delete direction_;
}

void MoveCommandParams::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const MoveCommandParams& MoveCommandParams::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_AdventureControl_2eproto::scc_info_MoveCommandParams.base);
  return *internal_default_instance();
}


void MoveCommandParams::Clear() {
// @@protoc_insertion_point(message_clear_start:AdventureControl.MoveCommandParams)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 0x00000001u) {
    GOOGLE_DCHECK(direction_ != NULL);
    direction_->Clear();
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool MoveCommandParams::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:AdventureControl.MoveCommandParams)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional .RemoteFortressReader.Coord direction = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_direction()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:AdventureControl.MoveCommandParams)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:AdventureControl.MoveCommandParams)
  return false;
#undef DO_
}

void MoveCommandParams::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:AdventureControl.MoveCommandParams)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional .RemoteFortressReader.Coord direction = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      1, this->_internal_direction(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:AdventureControl.MoveCommandParams)
}

size_t MoveCommandParams::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:AdventureControl.MoveCommandParams)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  // optional .RemoteFortressReader.Coord direction = 1;
  if (has_direction()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *direction_);
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void MoveCommandParams::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const MoveCommandParams*>(&from));
}

void MoveCommandParams::MergeFrom(const MoveCommandParams& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:AdventureControl.MoveCommandParams)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_direction()) {
    mutable_direction()->::RemoteFortressReader::Coord::MergeFrom(from.direction());
  }
}

void MoveCommandParams::CopyFrom(const MoveCommandParams& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:AdventureControl.MoveCommandParams)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MoveCommandParams::IsInitialized() const {
  return true;
}

void MoveCommandParams::Swap(MoveCommandParams* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MoveCommandParams::InternalSwap(MoveCommandParams* other) {
  using std::swap;
  swap(direction_, other->direction_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string MoveCommandParams::GetTypeName() const {
  return "AdventureControl.MoveCommandParams";
}


// ===================================================================

void MovementOption::InitAsDefaultInstance() {
  ::AdventureControl::_MovementOption_default_instance_._instance.get_mutable()->dest_ = const_cast< ::RemoteFortressReader::Coord*>(
      ::RemoteFortressReader::Coord::internal_default_instance());
  ::AdventureControl::_MovementOption_default_instance_._instance.get_mutable()->source_ = const_cast< ::RemoteFortressReader::Coord*>(
      ::RemoteFortressReader::Coord::internal_default_instance());
  ::AdventureControl::_MovementOption_default_instance_._instance.get_mutable()->grab_ = const_cast< ::RemoteFortressReader::Coord*>(
      ::RemoteFortressReader::Coord::internal_default_instance());
}
void MovementOption::clear_dest() {
  if (dest_ != NULL) dest_->Clear();
  clear_has_dest();
}
void MovementOption::clear_source() {
  if (source_ != NULL) source_->Clear();
  clear_has_source();
}
void MovementOption::clear_grab() {
  if (grab_ != NULL) grab_->Clear();
  clear_has_grab();
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MovementOption::kDestFieldNumber;
const int MovementOption::kSourceFieldNumber;
const int MovementOption::kGrabFieldNumber;
const int MovementOption::kMovementTypeFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MovementOption::MovementOption()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_AdventureControl_2eproto::scc_info_MovementOption.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:AdventureControl.MovementOption)
}
MovementOption::MovementOption(const MovementOption& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_dest()) {
    dest_ = new ::RemoteFortressReader::Coord(*from.dest_);
  } else {
    dest_ = NULL;
  }
  if (from.has_source()) {
    source_ = new ::RemoteFortressReader::Coord(*from.source_);
  } else {
    source_ = NULL;
  }
  if (from.has_grab()) {
    grab_ = new ::RemoteFortressReader::Coord(*from.grab_);
  } else {
    grab_ = NULL;
  }
  movement_type_ = from.movement_type_;
  // @@protoc_insertion_point(copy_constructor:AdventureControl.MovementOption)
}

void MovementOption::SharedCtor() {
  ::memset(&dest_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&movement_type_) -
      reinterpret_cast<char*>(&dest_)) + sizeof(movement_type_));
}

MovementOption::~MovementOption() {
  // @@protoc_insertion_point(destructor:AdventureControl.MovementOption)
  SharedDtor();
}

void MovementOption::SharedDtor() {
  if (this != internal_default_instance()) delete dest_;
  if (this != internal_default_instance()) delete source_;
  if (this != internal_default_instance()) delete grab_;
}

void MovementOption::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const MovementOption& MovementOption::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_AdventureControl_2eproto::scc_info_MovementOption.base);
  return *internal_default_instance();
}


void MovementOption::Clear() {
// @@protoc_insertion_point(message_clear_start:AdventureControl.MovementOption)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 7u) {
    if (cached_has_bits & 0x00000001u) {
      GOOGLE_DCHECK(dest_ != NULL);
      dest_->Clear();
    }
    if (cached_has_bits & 0x00000002u) {
      GOOGLE_DCHECK(source_ != NULL);
      source_->Clear();
    }
    if (cached_has_bits & 0x00000004u) {
      GOOGLE_DCHECK(grab_ != NULL);
      grab_->Clear();
    }
  }
  movement_type_ = 0;
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool MovementOption::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:AdventureControl.MovementOption)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional .RemoteFortressReader.Coord dest = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_dest()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional .RemoteFortressReader.Coord source = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_source()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional .RemoteFortressReader.Coord grab = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(26u /* 26 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_grab()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional .AdventureControl.CarefulMovementType movement_type = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(32u /* 32 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::AdventureControl::CarefulMovementType_IsValid(value)) {
            set_movement_type(static_cast< ::AdventureControl::CarefulMovementType >(value));
          } else {
            unknown_fields_stream.WriteVarint32(32u);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:AdventureControl.MovementOption)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:AdventureControl.MovementOption)
  return false;
#undef DO_
}

void MovementOption::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:AdventureControl.MovementOption)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional .RemoteFortressReader.Coord dest = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      1, this->_internal_dest(), output);
  }

  // optional .RemoteFortressReader.Coord source = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      2, this->_internal_source(), output);
  }

  // optional .RemoteFortressReader.Coord grab = 3;
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      3, this->_internal_grab(), output);
  }

  // optional .AdventureControl.CarefulMovementType movement_type = 4;
  if (cached_has_bits & 0x00000008u) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      4, this->movement_type(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:AdventureControl.MovementOption)
}

size_t MovementOption::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:AdventureControl.MovementOption)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  if (_has_bits_[0 / 32] & 15u) {
    // optional .RemoteFortressReader.Coord dest = 1;
    if (has_dest()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *dest_);
    }

    // optional .RemoteFortressReader.Coord source = 2;
    if (has_source()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *source_);
    }

    // optional .RemoteFortressReader.Coord grab = 3;
    if (has_grab()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *grab_);
    }

    // optional .AdventureControl.CarefulMovementType movement_type = 4;
    if (has_movement_type()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::EnumSize(this->movement_type());
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void MovementOption::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const MovementOption*>(&from));
}

void MovementOption::MergeFrom(const MovementOption& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:AdventureControl.MovementOption)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 15u) {
    if (cached_has_bits & 0x00000001u) {
      mutable_dest()->::RemoteFortressReader::Coord::MergeFrom(from.dest());
    }
    if (cached_has_bits & 0x00000002u) {
      mutable_source()->::RemoteFortressReader::Coord::MergeFrom(from.source());
    }
    if (cached_has_bits & 0x00000004u) {
      mutable_grab()->::RemoteFortressReader::Coord::MergeFrom(from.grab());
    }
    if (cached_has_bits & 0x00000008u) {
      movement_type_ = from.movement_type_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void MovementOption::CopyFrom(const MovementOption& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:AdventureControl.MovementOption)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MovementOption::IsInitialized() const {
  return true;
}

void MovementOption::Swap(MovementOption* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MovementOption::InternalSwap(MovementOption* other) {
  using std::swap;
  swap(dest_, other->dest_);
  swap(source_, other->source_);
  swap(grab_, other->grab_);
  swap(movement_type_, other->movement_type_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string MovementOption::GetTypeName() const {
  return "AdventureControl.MovementOption";
}


// ===================================================================

void MenuContents::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MenuContents::kCurrentMenuFieldNumber;
const int MenuContents::kMovementsFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MenuContents::MenuContents()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_AdventureControl_2eproto::scc_info_MenuContents.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:AdventureControl.MenuContents)
}
MenuContents::MenuContents(const MenuContents& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      movements_(from.movements_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  current_menu_ = from.current_menu_;
  // @@protoc_insertion_point(copy_constructor:AdventureControl.MenuContents)
}

void MenuContents::SharedCtor() {
  current_menu_ = 0;
}

MenuContents::~MenuContents() {
  // @@protoc_insertion_point(destructor:AdventureControl.MenuContents)
  SharedDtor();
}

void MenuContents::SharedDtor() {
}

void MenuContents::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const MenuContents& MenuContents::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_AdventureControl_2eproto::scc_info_MenuContents.base);
  return *internal_default_instance();
}


void MenuContents::Clear() {
// @@protoc_insertion_point(message_clear_start:AdventureControl.MenuContents)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  movements_.Clear();
  current_menu_ = 0;
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool MenuContents::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:AdventureControl.MenuContents)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional .AdventureControl.AdvmodeMenu current_menu = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::AdventureControl::AdvmodeMenu_IsValid(value)) {
            set_current_menu(static_cast< ::AdventureControl::AdvmodeMenu >(value));
          } else {
            unknown_fields_stream.WriteVarint32(8u);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated .AdventureControl.MovementOption movements = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
                input, add_movements()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:AdventureControl.MenuContents)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:AdventureControl.MenuContents)
  return false;
#undef DO_
}

void MenuContents::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:AdventureControl.MenuContents)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional .AdventureControl.AdvmodeMenu current_menu = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      1, this->current_menu(), output);
  }

  // repeated .AdventureControl.MovementOption movements = 2;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->movements_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      2,
      this->movements(static_cast<int>(i)),
      output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:AdventureControl.MenuContents)
}

size_t MenuContents::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:AdventureControl.MenuContents)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  // repeated .AdventureControl.MovementOption movements = 2;
  {
    unsigned int count = static_cast<unsigned int>(this->movements_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->movements(static_cast<int>(i)));
    }
  }

  // optional .AdventureControl.AdvmodeMenu current_menu = 1;
  if (has_current_menu()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->current_menu());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void MenuContents::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const MenuContents*>(&from));
}

void MenuContents::MergeFrom(const MenuContents& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:AdventureControl.MenuContents)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  movements_.MergeFrom(from.movements_);
  if (from.has_current_menu()) {
    set_current_menu(from.current_menu());
  }
}

void MenuContents::CopyFrom(const MenuContents& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:AdventureControl.MenuContents)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MenuContents::IsInitialized() const {
  return true;
}

void MenuContents::Swap(MenuContents* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MenuContents::InternalSwap(MenuContents* other) {
  using std::swap;
  CastToBase(&movements_)->InternalSwap(CastToBase(&other->movements_));
  swap(current_menu_, other->current_menu_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string MenuContents::GetTypeName() const {
  return "AdventureControl.MenuContents";
}


// ===================================================================

void MiscMoveParams::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MiscMoveParams::kTypeFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MiscMoveParams::MiscMoveParams()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_AdventureControl_2eproto::scc_info_MiscMoveParams.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:AdventureControl.MiscMoveParams)
}
MiscMoveParams::MiscMoveParams(const MiscMoveParams& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  type_ = from.type_;
  // @@protoc_insertion_point(copy_constructor:AdventureControl.MiscMoveParams)
}

void MiscMoveParams::SharedCtor() {
  type_ = 0;
}

MiscMoveParams::~MiscMoveParams() {
  // @@protoc_insertion_point(destructor:AdventureControl.MiscMoveParams)
  SharedDtor();
}

void MiscMoveParams::SharedDtor() {
}

void MiscMoveParams::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const MiscMoveParams& MiscMoveParams::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_AdventureControl_2eproto::scc_info_MiscMoveParams.base);
  return *internal_default_instance();
}


void MiscMoveParams::Clear() {
// @@protoc_insertion_point(message_clear_start:AdventureControl.MiscMoveParams)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  type_ = 0;
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool MiscMoveParams::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:AdventureControl.MiscMoveParams)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional .AdventureControl.MiscMoveType type = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::AdventureControl::MiscMoveType_IsValid(value)) {
            set_type(static_cast< ::AdventureControl::MiscMoveType >(value));
          } else {
            unknown_fields_stream.WriteVarint32(8u);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:AdventureControl.MiscMoveParams)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:AdventureControl.MiscMoveParams)
  return false;
#undef DO_
}

void MiscMoveParams::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:AdventureControl.MiscMoveParams)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional .AdventureControl.MiscMoveType type = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      1, this->type(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:AdventureControl.MiscMoveParams)
}

size_t MiscMoveParams::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:AdventureControl.MiscMoveParams)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  // optional .AdventureControl.MiscMoveType type = 1;
  if (has_type()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->type());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void MiscMoveParams::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const MiscMoveParams*>(&from));
}

void MiscMoveParams::MergeFrom(const MiscMoveParams& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:AdventureControl.MiscMoveParams)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_type()) {
    set_type(from.type());
  }
}

void MiscMoveParams::CopyFrom(const MiscMoveParams& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:AdventureControl.MiscMoveParams)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MiscMoveParams::IsInitialized() const {
  return true;
}

void MiscMoveParams::Swap(MiscMoveParams* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MiscMoveParams::InternalSwap(MiscMoveParams* other) {
  using std::swap;
  swap(type_, other->type_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string MiscMoveParams::GetTypeName() const {
  return "AdventureControl.MiscMoveParams";
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace AdventureControl
namespace google {
namespace protobuf {
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::AdventureControl::MoveCommandParams* Arena::CreateMaybeMessage< ::AdventureControl::MoveCommandParams >(Arena* arena) {
  return Arena::CreateInternal< ::AdventureControl::MoveCommandParams >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::AdventureControl::MovementOption* Arena::CreateMaybeMessage< ::AdventureControl::MovementOption >(Arena* arena) {
  return Arena::CreateInternal< ::AdventureControl::MovementOption >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::AdventureControl::MenuContents* Arena::CreateMaybeMessage< ::AdventureControl::MenuContents >(Arena* arena) {
  return Arena::CreateInternal< ::AdventureControl::MenuContents >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::AdventureControl::MiscMoveParams* Arena::CreateMaybeMessage< ::AdventureControl::MiscMoveParams >(Arena* arena) {
  return Arena::CreateInternal< ::AdventureControl::MiscMoveParams >(arena);
}
}  // namespace protobuf
}  // namespace google

// @@protoc_insertion_point(global_scope)
